use fluent_bit_rust::output;

use std::io::Write;

use std::path::Path;
use std::fs::File;
use std::fs::OpenOptions;
use std::fs::Metadata;
use std::fmt;

use std::mem;
use std::io::ErrorKind;
use std::io::Error;

use chrono::prelude::*;
use uuid::Uuid;
use json::object::Object;

use rusqlite::{Connection, Result, NO_PARAMS};

use std::sync::Mutex;



// Plugin configuration options
struct PluginConfiguration<'a> {
    // Store a random ID - all the buffers generated by the plugin
    // will be prefixed with this ID - this helps in differentiating
    // files created in case multiple instances of the plugin are
    // runnig in a concurrent environment.
    plugin_instance_id: &'a str,

    // Path to a folder where buffer files should be stored
    buffer_path: &'a str,

    // Path to the folder where the sqlite DB tracking buffers
    // is stored
    db_path: &'a str,

    // If the size of the current buffer exceeds this,
    // it is renamed according to pattern and a new live
    // bffer is created
    buffer_limit: &'a u64,

    // curret buffer
    current_buffer: &'a File
}


// Getter and setter methods for the plugin fields
impl PluginConfiguration<'static> {
    fn get_buffer_path(&self) -> &'static str {
        &self.buffer_path
    }

    fn get_db_path(&self) -> &'static str {
        &self.db_path
    }

    fn get_buffer_limit(&self) -> &'static u64 {
        &self.buffer_limit
    }

    fn get_plugin_instance_id(&mut self) -> &'static str {
        &self.plugin_instance_id
    }
    
    fn set_buffer_path(&mut self, buffer_path: &'static str) {
        self.buffer_path = buffer_path;
    }

    fn set_db_path(&mut self, db_path: &'static str) {
        self.db_path = db_path;
    }

    fn set_buffer_limit(&mut self, buffer_limit: &'static u64)  {
        self.buffer_limit = buffer_limit;
    }

    fn new_current_buffer(&mut self) {
        let buffer_path = format!("{}/fb-buffer.txt", self.get_buffer_path());
        let mut file = OpenOptions::new().append(true).read(true).create(true).open(&buffer_path).unwrap();
            
        self.current_buffer = Box::leak(Box::new(file));
    }

    fn rotate_current_buffer(&mut self) {
        let buffer_path = format!("{}/fb-buffer.txt", self.get_buffer_path());
        let archived_buffer_path = format!("{}/{}_fb-buffer-{}.txt",
                                           get_buffer_path(),
                                           get_plugin_instance_id(),
                                           Utc::now());


        match std::fs::rename(&buffer_path, &archived_buffer_path) {
            Ok(_) => {
                let conn = Connection::open(self.get_db_path()).unwrap();
                conn.execute("INSERT INTO buffers (path, status) VALUES (?1, ?2)", &[&archived_buffer_path, "rotated"]);
                drop(self.current_buffer);
            },
            Err(_) => ()
        }
        
        self.new_current_buffer();
    }

    fn get_current_buffer(&self) -> &'static File {
        &self.current_buffer
    }
}


// Initialize the sqlite DB
pub fn init_db() -> Result<()> {
    let db_path = get_db_path();

    let conn = Connection::open_with_flags(db_path, rusqlite::OpenFlags::SQLITE_OPEN_READ_WRITE)?;
    conn.execute("CREATE TABLE IF NOT EXISTS buffers (path text, status text);", NO_PARAMS)?;
    
    Ok(())
}



// Rotate the current buffer
pub fn rotate_current_buffer() {
    let mut plugin_conf = PLUGIN_CONFIG.lock().unwrap();
    plugin_conf.rotate_current_buffer();
}

// Default buffer limit size is 256 MB
static DEFAULT_BUFFER_LIMIT: u64 = 256_000_000;

lazy_static! {
    static ref PLUGIN_CONFIG: Mutex<PluginConfiguration<'static>> = {
        let mut cfg = PluginConfiguration {
            buffer_path: "",
            db_path: "",
            buffer_limit: &DEFAULT_BUFFER_LIMIT,
            plugin_instance_id: Box::leak(Uuid::new_v4().to_string().into_boxed_str()),
            current_buffer: Box::leak(Box::new(File::create("/tmp/test").unwrap()))
        };

        Mutex::new(cfg)
    };
}


// Given the plugin object, extract the configuration parameters and store in the
// global confuguration singleton struct reference
pub fn register_globals(plugin: *mut output::FLBOutPlugin) -> std::io::Result<()> {
    let mut plugin_conf = PLUGIN_CONFIG.lock().unwrap();
    
    let buffer_path = unsafe { output::FLBPluginConfigKey(plugin, "Buffer_Path") };


    // Note that in the following sections, we extend the lifetime of the configuration
    // values to static by leaking memory (ie, they will never be `freed`) - we will
    // drop these manually when the plugin exit callback is invoked by fluent-bit
    match buffer_path {
        Some(str_path) => {
            plugin_conf.set_buffer_path(Box::leak(str_path.into_boxed_str()));
        },
        _ => return Err(Error::new(ErrorKind::NotFound, "Buffer_Path configuration is required."))
    };

    let db_path = unsafe { output::FLBPluginConfigKey(plugin, "DB_Path") };
    
    match db_path {
        Some(str_path) => plugin_conf.set_db_path(Box::leak(str_path.into_boxed_str())),
        _ => return Err(Error::new(ErrorKind::NotFound, "DB_Path configuration parameter is required"))
    };

    let buffer_limit = unsafe {
        output::FLBPluginConfigKey(plugin, "Rotate_When_Size_Exceeds").map(|val: String| {
            return (val.parse::<u64>()).unwrap_or(DEFAULT_BUFFER_LIMIT);
        })
    };

    match buffer_limit {
        Some(limit) => plugin_conf.set_buffer_limit(Box::leak(Box::new(limit))),
        _ => {
            println!("Parameter `Rotate_When_Size_Exceeds` not specified, using default value {}", DEFAULT_BUFFER_LIMIT);
            plugin_conf.set_buffer_limit(&DEFAULT_BUFFER_LIMIT)
        }
    }
    
    plugin_conf.new_current_buffer();

    // Drop the mutex lock here else further calls to lock the same mutex
    // in deeper scopes will block and never exit.
    drop(plugin_conf);
    
    match init_db() {
        Err(e) => {
            println!("Failed to init DB:  {}", e);
            return Err(Error::new(ErrorKind::NotFound, e.to_string()))
        },
        Ok(_) => (),
    }

    
    return Ok(())
}


// Given a JSON of the log, write it to the buffer and if
// the buffer exceeds 100mb push it to S3 and log the same
// in the sqlite database.
pub fn write_log_to_buffer(log: String) -> i32 {
    let mut config = PLUGIN_CONFIG.lock().unwrap();
   
    let mut buffer = config.get_current_buffer();
    
    match buffer.write(log.as_bytes()) {
        Err(message) => {
            println!("Failed to write logs to disk - retrying : {}", message);
            return output::FLB_RETRY;
        },
        _ => (),
    }

    
    let meta = buffer.metadata().map(|m: Metadata| {
        m.len()
    });
    
    match meta {
        Ok(size) if size > *get_buffer_limit() => {
            println!("File is larger than chunk - rotating the file {}", size);
            config.rotate_current_buffer();
        },
        Err(error) => println!("Error metadata extract: {}", error),
        _ => println!("Could not extract file metadata"),
    }
            
    drop(config);       

    return output::FLB_OK;
}

pub fn get_buffer_path() ->  &'static str {
    let mut plugin_conf = PLUGIN_CONFIG.lock().unwrap();
    return plugin_conf.get_buffer_path();
}

pub fn get_db_path() -> &'static str {
    let mut plugin_conf = PLUGIN_CONFIG.lock().unwrap();
    return plugin_conf.get_db_path();
}

pub fn get_buffer_limit() -> &'static u64 {
    let mut plugin_conf = PLUGIN_CONFIG.lock().unwrap();
    return plugin_conf.get_buffer_limit();
}

pub fn get_current_buffer_path() -> String {
    let instance_id = get_plugin_instance_id();
    format!("{}/{}_fb-buffer.txt", get_buffer_path(), instance_id)
}

pub fn get_current_buffer() -> &'static File {
    let mut plugin_conf = PLUGIN_CONFIG.lock().unwrap();
    return plugin_conf.get_current_buffer()
}

fn get_plugin_instance_id() -> &'static str {
    let mut plugin_conf = PLUGIN_CONFIG.lock().unwrap();
    return plugin_conf.get_plugin_instance_id();
}
